<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xmlns:xc="urn:xhtml-compiler"
  xml:lang="en">
<head>
  <title>HTML Purifier Sucks - HTML Purifier</title>
  <xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
  <meta name="keywords" content="HTMLPurifier, HTML Purifier, HTML, filter, sucks, devils advocate, evil, bad" />
</head>
<body>

<xi:include href="common-header.xml" xpointer="xpointer(/*/node())" />

<div id="main">
<h1 id="title">HTML Purifier Sucks</h1>

<div id="content">

<blockquote class="fancy">
  <div class="quote">
    ...needless to say, I don't think I'll bother investigating further!
  </div>
  <div class="origin">
    &mdash; Stormrider on <a href="http://www.sitepoint.com/forums/showpost.php?p=3621314&amp;postcount=119">SitePoint Forums</a>
  </div>
</blockquote>

<p>
  Contrary to what <a href="comparison">this comparison page</a>
  suggests, HTML Purifier sucks. It swallows oceans, it drinks blood,
  and it is more effective than your dust-busting Hoover 3000. Why does it
  suck? How can we make it un-sucky?
</p>

<div class="warning">
  This document is currently under construction.
</div>

<div id="toc" />

<h2>Bloat</h2>

<p>
  As of version 2.1.3, HTML Purifier's library folder contains
  <strong>164 files</strong> in <strong>30 folders</strong>, weighing
  at about 696 kilobytes. For comparison, the CodeIgniter 
  web application framework contains 147 files, 29 folders and weighs
  902 kilobytes.
</p>

<p>
  These back-of-a-napkin statistics are very telling about HTML Purifier's
  internal architecture: object-oriented, one class per file and small
  components, to the extreme. It also works against HTML Purifier when
  it comes to the performance department. For most input strings, the
  memory footprint from this library's source code is higher than the
  memory used actually processing the HTML (four megabytes,
  <a href="http://forums.devnetwork.net/viewtopic.php?p=405175#405175">last I checked</a>.)
</p>

<h2>Performance</h2>

<p>
  HTML Purifier is extremely slow. Various benchmarks have shown HTML
  Purifier to be an order of a magnitude slower than comparable solutions.
</p>

<h2>Whitespace</h2>

<p>
  The <a href="http://www.sitepoint.com/forums/showpost.php?p=3621314&amp;postcount=119">Stormrider
  quote</a> at the very beginning of this document is for one very
  specific problem: whitespace.
</p>

<h2>Data-loss</h2>

<p>
  It is trivially easy to nuke the contents of a document by inserting
  a <code>&lt;/div&gt;</code> tag near the beginning, when DOMLex
  is being used.
</p>

</div>
</div>
</body>
</html>
